"""
    BIMData API

    BIMData API is a tool to interact with your models stored on BIMData’s servers.     Through the API, you can manage your projects, the clouds, upload your IFC files and manage them through endpoints.  # noqa: E501

    The version of the OpenAPI document: v1 (v1)
    Contact: support@bimdata.io
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from bimdata-api-client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from bimdata-api-client.exceptions import ApiAttributeError



class Extensions(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'topic_type': ([str],),  # noqa: E501
            'topic_status': ([str],),  # noqa: E501
            'topic_label': ([str],),  # noqa: E501
            'priority': ([str],),  # noqa: E501
            'stage': ([str],),  # noqa: E501
            'user_id_type': ([str],),  # noqa: E501
            'priority_colors': ([str, none_type],),  # noqa: E501
            'topic_status_colors': ([str, none_type],),  # noqa: E501
            'snippet_type': ([str, none_type], none_type,),  # noqa: E501
            'project_actions': ([str],),  # noqa: E501
            'topic_actions': ([str],),  # noqa: E501
            'comment_actions': ([str],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'topic_type': 'topic_type',  # noqa: E501
        'topic_status': 'topic_status',  # noqa: E501
        'topic_label': 'topic_label',  # noqa: E501
        'priority': 'priority',  # noqa: E501
        'stage': 'stage',  # noqa: E501
        'user_id_type': 'user_id_type',  # noqa: E501
        'priority_colors': 'priority_colors',  # noqa: E501
        'topic_status_colors': 'topic_status_colors',  # noqa: E501
        'snippet_type': 'snippet_type',  # noqa: E501
        'project_actions': 'project_actions',  # noqa: E501
        'topic_actions': 'topic_actions',  # noqa: E501
        'comment_actions': 'comment_actions',  # noqa: E501
    }

    read_only_vars = {
        'topic_type',  # noqa: E501
        'topic_status',  # noqa: E501
        'topic_label',  # noqa: E501
        'priority',  # noqa: E501
        'stage',  # noqa: E501
        'user_id_type',  # noqa: E501
        'snippet_type',  # noqa: E501
        'project_actions',  # noqa: E501
        'topic_actions',  # noqa: E501
        'comment_actions',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, topic_type, topic_status, topic_label, priority, stage, user_id_type, priority_colors, topic_status_colors, snippet_type, project_actions, topic_actions, comment_actions, *args, **kwargs):  # noqa: E501
        """Extensions - a model defined in OpenAPI

        Args:
            topic_type ([str]):
            topic_status ([str]):
            topic_label ([str]):
            priority ([str]):
            stage ([str]):
            user_id_type ([str]):
            priority_colors ([str, none_type]): Non standard field. Arrays of priorities and this array are in the same order.
            topic_status_colors ([str, none_type]): Non standard field. Arrays of statuses and this array are in the same order.
            snippet_type ([str, none_type], none_type): Snippet are not yet supported. This field will always be null.
            project_actions ([str]):
            topic_actions ([str]):
            comment_actions ([str]):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.topic_type = topic_type
        self.topic_status = topic_status
        self.topic_label = topic_label
        self.priority = priority
        self.stage = stage
        self.user_id_type = user_id_type
        self.priority_colors = priority_colors
        self.topic_status_colors = topic_status_colors
        self.snippet_type = snippet_type
        self.project_actions = project_actions
        self.topic_actions = topic_actions
        self.comment_actions = comment_actions
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, priority_colors, topic_status_colors, *args, **kwargs):  # noqa: E501
        """Extensions - a model defined in OpenAPI

            priority_colors ([str, none_type]): Non standard field. Arrays of priorities and this array are in the same order.
            topic_status_colors ([str, none_type]): Non standard field. Arrays of statuses and this array are in the same order.
        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.priority_colors = priority_colors
        self.topic_status_colors = topic_status_colors
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
